--
-- ChangeWorkParticlesVis
--
-- @author  nilBrain
-- @date    22/11/2020


ChangeWorkParticlesVis = {};

function ChangeWorkParticlesVis.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(WorkParticles, specializations);
end;

function ChangeWorkParticlesVis.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", ChangeWorkParticlesVis);
end;

function ChangeWorkParticlesVis:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    local spec = self.spec_workParticles;
    if self.isClient then
        for _,ps in pairs(spec.particles) do
            for _,  mapping in ipairs(ps.mappings) do
                local nodeEnabled = self:getDoGroundManipulation();
                if nodeEnabled then
                    nodeEnabled = mapping.groundRefNode.isActive;
                end;
                if mapping.movingDirection ~= nil then
                    nodeEnabled = nodeEnabled and mapping.movingDirection == self.movingDirection;
                end;
                ParticleUtil.setEmittingState(mapping.particleSystem, nodeEnabled);
            end;
        end;
    end;
end;